<template>
  <div>
    <FormSearchComponent
      @event-results-search="loadResultsSearch"
      @event-reset-results-search="resetResultsSearch"
    />
    <table class="container font-size">
      <thead>
      </thead>
      <tbody>
      <tr v-bind:key="indexResp" v-for="(item, indexResp) in responseSearch">
        <div class="th" v-if="item.tags==null || item.tags.length==0">
          <ArrowEffect
            :name='responseSearch[indexResp].displayName'
            :url='item.url'
          />
          <p v-if="item.description !== null">{{item.description}}</p>
          <p v-else style="font-style: italic">Pas de description</p>
        </div>
        <div v-else>
          <div class="th" v-bind:key="indexTag" v-for="(tag, indexTag) in item.tags">
            <ArrowEffect
              :name='responseSearch[indexResp].displayName'
              :url='item.url'
            />
            <p v-if="item.description !== null">{{item.description}}</p>
            <p v-else style="font-style: italic">Pas de description</p>
            <vsa-list :style="customVsaHiglightColor">
              <vsa-item>
                <vsa-heading>
                  <div class="font-size">{{tag.tagName}}</div>
                </vsa-heading>
                <vsa-content>
                  <table class="table" :style="customColorStyle">
                    <thead>
                      <tr>
                      </tr>
                    </thead>
                    <tbody>
                      <tr v-bind:key="indexField" v-for="(fields, indexField) in tag.fields">
                        <th scope="name">{{fields.name}}</th>
                        <td ><div v-if="fields.value != '| '">{{fields.value}}</div></td>
                        <td>{{fields.type}}</td>
                      </tr>
                    </tbody>
                  </table>
                </vsa-content>
              </vsa-item>
            </vsa-list>
            <p v-if="columnListArray[indexResp]!='' && tag.idBigQuery.split('\.').length > 2"><b>Liste des colonnes:</b> {{ columnListArray[indexResp] }}</p>
          </div>
        </div>
      </tr>
      </tbody>
    </table>
  </div>
</template>

<script>
import Vue from 'vue'
import custom from '@/shared/custom'
import ArrowEffect from '@/components/search/ArrowEffect'
import FormSearchComponent from '@/components/search/FormSearchComponent.vue'
export default {
  data () {
    return {
      response: [],
      responseSearch: [],
      columnListArray: []
    }
  },
  components: {
    ArrowEffect,
    FormSearchComponent
  },
  methods: {
    resetResultsSearch () {
      Vue.prototype.$responseSearch = []
      this.responseSearch = []
    },
    loadResultsSearch () {
      this.$responseSearch.forEach(item => {
        this.response.push({
          type: item.subtype,
          name: item.displayName,
          link: item.url
        })
      })
      this.responseSearch = this.$responseSearch
      this.getColumnList()
    },
    details (index) {
      Vue.prototype.$responseSearchDetail = this.$responseSearch[index]
      this.$router.push('/details')
    },
    getColumnList () {
      // console.log(this.responseSearch)
      for (const item in this.responseSearch) {
        if (this.responseSearch[item].columns != null) {
          let stringList = ''
          for (const column in this.responseSearch[item].columns) {
            stringList += this.responseSearch[item].columns[column].name + ' '
          }
          this.columnListArray.push(stringList)
        } else {
          this.columnListArray.push('')
        }
      }
    }
  },
  computed: {
    customColorStyle () {
      return custom.customColorStyle()
    },
    customVsaHiglightColor () {
      return custom.customVsaHiglightColor()
    }
  },
  mounted () {
    custom.getGoodItemAndColorIt(this.$route.path)
  }
}
</script>

<style scoped>

.center {
  margin-top: 15px;
  text-align: center;
}
p {
  margin-left: 20px;
}
.table {
  border-spacing: 0;
}
.th {
  padding-top:20px
}
.table td, .table th {
  border: 1px solid #ccc;
}
.container {
  border-top: 1px solid #ccc;
  padding: 0;
  width: 94%;
  max-width: 100%;
  margin-left: 80px;
}
th, td {
  font-size: 13px;
}
.font-size {
  font-size: 14px;
}
.vsa-list{
  --vsa-max-width:1500px;
  --vsa-heading-padding:5px 20px 5px 20px;
  --vsa-default-icon-size: 0.5;
  margin-bottom: 10px;
}
</style>
